#include "sdio.h"
#include "sd.h"
#include <STC8H.H>
#include "delay.h"

unsigned long RCA;
unsigned short crc0=0,crc1=0,crc2=0,crc3=0;
unsigned char CSD[17];
unsigned char CardStatus=0;
void SD_Cmd(unsigned char cmd,unsigned long arg)
{
	unsigned char dat[5]={0};
	unsigned char *argp=&arg;
	unsigned char crc7=0;

	dat[0]=cmd|0x40;
	dat[1]=*argp++;
	dat[2]=*argp++;
	dat[3]=*argp++;
	dat[4]=*argp;
	crc7=crc7_mmc(dat,5);
	CmdByte(dat[0]);
	CmdByte(dat[1]);
	CmdByte(dat[2]);
	CmdByte(dat[3]);
	CmdByte(dat[4]);
	CmdByte(crc7);
}

void SD_Init()
{
	unsigned char i;
	SD_PinInit();
	for(i=0;i<100;i++)
	{
		CLK=0;
		delay_us(500);
		CLK=1;
		delay_us(500);
	}
	SD_Cmd(CMD0,0);
	emptyclk(64);
	SD_Cmd(CMD8,0x01AA);
	Reslow();
	do{
	SD_Cmd(CMD55,0);
	Reslow();
	SD_Cmd(CMD41,0x40F00000);
	Reslow();
	}while((0x80&reslowb[1])==0);
	SD_Cmd(CMD2,0);
	Reslong();
	SD_Cmd(CMD3,0);
	Reslow();
	RCA=0;
	RCA=reslowb[1];
	RCA<<=24;
	RCA|=(unsigned long)(reslowb[2])<<16;
	SD_GetCSD();
	SD_selecard();
	SD_Class10();
	SD_Bus_width();
	Timing=1;
}

void SD_selecard()
{
	SD_Cmd(CMD7,RCA);
	Reslow();
}


void SD_ReadBlock(unsigned char buf[],unsigned long address)
{
	unsigned int i=0;
	SD_Cmd(CMD17,address);
	do{
	emptyclk(1);
	}while(DAT0==1);
	for(i=0;i<512;i++)
	{
		buf[i]=Read4();
	}
	emptyclk(25);
}


void SD_WriteBlock(unsigned char buf[],unsigned long address)
{
	unsigned int i=0;
	CRC16_4Bits(buf);
	do{
	SD_Cmd(CMD24,address);
	Reslow();
	}while(reslowb[3]&0x01==0);
	dataStart();
	for(i=0;i<512;i++)
	Write4(buf[i]);
	Send4Bits_crc16();
	dataStop();
	emptyclk(16);
	do{
	emptyclk(1);
	}while(DAT0==0);
}

void CRC16_4Bits(unsigned char buf[])
{
	unsigned char xdata arr0[128],arr1[128],arr2[128],arr3[128],i;
	for(i=0;i<128;i++)
	{
		arr3[i]=0;
		arr2[i]=0;
		arr1[i]=0;
		arr0[i]=0;
		
		arr3[i]|=*buf&0x80;
		arr2[i]|=(*buf&0x40)<<1;
		arr1[i]|=(*buf&0x20)<<2;
		arr0[i]|=(*buf&0x10)<<3;

		arr3[i]|=(*buf&0x08)<<3;
		arr2[i]|=(*buf&0x04)<<4;
		arr1[i]|=(*buf&0x02)<<5;
		arr0[i]|=(*buf&0x01)<<6;
		buf++;
		arr3[i]|=(*buf&0x80)>>2;
		arr2[i]|=(*buf&0x40)>>1;
		arr1[i]|=(*buf&0x20);
		arr0[i]|=(*buf&0x10)<<1;

		arr3[i]|=(*buf&0x08)<<1;
		arr2[i]|=(*buf&0x04)<<2;
		arr1[i]|=(*buf&0x02)<<3;
		arr0[i]|=(*buf&0x01)<<4;
		buf++;
		arr3[i]|=(*buf&0x80)>>4;
		arr2[i]|=(*buf&0x40)>>3;
		arr1[i]|=(*buf&0x20)>>2;
		arr0[i]|=(*buf&0x10)>>1;

		arr3[i]|=(*buf&0x08)>>1;
		arr2[i]|=(*buf&0x04);
		arr1[i]|=(*buf&0x02)<<1;
		arr0[i]|=(*buf&0x01)<<2;
		buf++;
		arr3[i]|=(*buf&0x80)>>6;
		arr2[i]|=(*buf&0x40)>>5;
		arr1[i]|=(*buf&0x20)>>4;
		arr0[i]|=(*buf&0x10)>>3;

		arr3[i]|=(*buf&0x08)>>3;
		arr2[i]|=(*buf&0x04)>>2;
		arr1[i]|=(*buf&0x02)>>1;
		arr0[i]|=(*buf&0x01);
		buf++;
	}
	crc0=crc16_xmodem(arr0,128);
	crc1=crc16_xmodem(arr1,128);
	crc2=crc16_xmodem(arr2,128);
	crc3=crc16_xmodem(arr3,128);
}

void Send4Bits_crc16()
{
	unsigned char i;
	for(i=0;i<16;i++)
	{
		if(crc0&(0x8000>>i)){DAT0=1;}else{DAT0=0;}
		if(crc1&(0x8000>>i)){DAT1=1;}else{DAT1=0;}
		if(crc2&(0x8000>>i)){DAT2=1;}else{DAT2=0;}
		if(crc3&(0x8000>>i)){DAT3=1;}else{DAT3=0;}
		emptyclk(1);
	}
}


void SD_Class10()
{
	SD_Cmd(CMD20,0x40000000);
	Reslow();
	emptyclk(32);
	do{
	emptyclk(1);
	}while(DAT0==0);
}

void SD_Bus_width()
{
	SD_Cmd(CMD55,RCA);
	Reslow();
	SD_Cmd(CMD6,0x00000002);
	Reslow();
}

void SD_GetCardStatus()
{
	SD_Cmd(CMD13,RCA);
	Reslow();
}

void SD_GetCSD()
{
	unsigned char i=0;
	SD_Cmd(CMD9,RCA);
	Reslong();
	for(i=0;i<17;i++)
	{
		CSD[i]=reslongb[i];
	}
}

unsigned long SD_GetDriverSize()
{
	unsigned long driversize=0;
	driversize|=(unsigned long)(CSD[8]);
	driversize<<=8;
	driversize|=(unsigned long)(CSD[9]);
	driversize<<=8;
	driversize|=(unsigned long)(CSD[10]);
	driversize&=0x003FFFFF;
	driversize++;
	driversize<<=10;
	return driversize;
}

unsigned long *SD_GetCID()
{
	SD_Cmd(CMD10,RCA);
	Reslong();
	return reslongb;
}

